"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidLeftOperatorType_1 = __importDefault(require("@InternalErrors/InvalidLeftOperatorType"));
var ObjectVoid_1 = __importDefault(require("@Types/ObjectVoid"));
var ObjectBoolean_1 = __importDefault(require("@Types/ObjectBoolean"));
var OperatorBase = /** @class */ (function () {
    /**
     * Creates an instance of OperatorBase.
     * @param {ConstructorOf<TypeBase>} check
     * @memberof OperatorBase
     */
    function OperatorBase(check) {
        /**
         * @protected
         * @type {TypeBase}
         * @memberof OperatorBase
         */
        this.check = ObjectVoid_1.default;
        /**
         * @protected
         * @type {LeftType}
         * @memberof Operator
         */
        this.leftType = new ObjectVoid_1.default();
        /**
         * @protected
         * @type {RightType}
         * @memberof Operator
         */
        this.rightType = new ObjectVoid_1.default();
        this.check = check;
    }
    /**
     * @protected
     * @returns {(void | never)}
     * @memberof OperatorBase
     */
    OperatorBase.prototype.typeCheckLeft = function () {
        if (!this.leftType.equalsTo(this.check)) {
            throw InvalidLeftOperatorType_1.default.create(this, this.leftType);
        }
        return new ObjectBoolean_1.default(true);
    };
    /**
     * @protected
     * @returns {(void | never)}
     * @memberof OperatorBase
     */
    OperatorBase.prototype.typeCheckRight = function () {
        if (!this.leftType.equalsTo(this.check)) {
            throw InvalidLeftOperatorType_1.default.create(this, this.leftType);
        }
        return new ObjectBoolean_1.default(true);
    };
    /**
     * @param {LeftType} Type
     * @memberof Operator
     */
    OperatorBase.prototype.left = function (Type) {
        this.leftType = Type;
        return this;
    };
    /**
     * @param {RightType} Type
     * @memberof Operator
     */
    OperatorBase.prototype.right = function (Type) {
        this.rightType = Type;
        return this;
    };
    return OperatorBase;
}());
exports.default = OperatorBase;
