"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TryCatch_1 = __importDefault(require("@Operators/TryCatch"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectFunction_1 = __importDefault(require("@Types/ObjectFunction"));
describe("Try Catch", function () {
    test("it works", function () {
        var mock = jest.fn();
        var fn1 = new ObjectFunction_1.default(function () { throw ""; });
        var fn2 = new ObjectFunction_1.default(mock);
        var fn3 = new ObjectFunction_1.default(function () { return new ObjectString_1.default("fooo"); });
        var op = new TryCatch_1.default();
        op.try(fn1);
        op.catch(fn2);
        expect(function () { return op.apply(); }).not.toThrowError();
        expect(mock).toHaveBeenCalled();
        op.try(fn3);
        expect(op.apply().equalsTo(ObjectString_1.default)).toBeTruthy();
    });
});
