"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
function mathOperatorBase(Operator, Left, Right) {
    return function (leftValue, rightValue, expected) {
        var op = new Operator();
        var left = new Left(leftValue);
        var right = new Right(rightValue);
        expect(function () { return op.left(left); }).not.toThrowError();
        expect(function () { return op.right(right); }).not.toThrowError();
        expect(function () { return op.apply(); }).not.toThrowError();
        expect(op.apply().value()).toEqual(expected);
    };
}
exports.mathOperatorBase = mathOperatorBase;
function mathOperatorBaseThrow(Operator, ThrowableType) {
    var op = new Operator();
    op.left(new ThrowableType(TypeBase_1.default.skipToken));
    op.right(new ThrowableType(TypeBase_1.default.skipToken));
    expect(function () { return op.apply(); }).toThrowError();
}
exports.mathOperatorBaseThrow = mathOperatorBaseThrow;
