"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectVoid_1 = __importDefault(require("@Types/ObjectVoid"));
function construct(Type, args) {
    return new Type(args);
}
exports.construct = construct;
function createType(TypeName) {
    var _a;
    var map = (_a = {},
        _a[TypeName.value()] = function (arg) {
            this["underlyingValue"] = arg;
        },
        _a);
    var ctor = map[TypeName.value()];
    ctor.prototype = TypeBase_1.default.prototype;
    ctor.prototype.name = function () {
        return "[object " + TypeName.value() + "]";
    };
    ctor.skipToken = TypeBase_1.default.skipToken;
    return ctor;
}
exports.createType = createType;
function defineProperty(Type, propertyName, property) {
    Type.prototype[propertyName.value()] = property;
    return new ObjectVoid_1.default();
}
exports.defineProperty = defineProperty;
function typeOf(Type) {
    return construct(Type, TypeBase_1.default.skipToken).name();
}
exports.typeOf = typeOf;
