"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Reflection = __importStar(require("@Reflection/Reflection"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectArray_1 = __importDefault(require("@Types/ObjectArray"));
var ObjectObject_1 = __importDefault(require("@Types/ObjectObject"));
describe("reflection", function () {
    test("construct", function () {
        expect(Reflection.construct(ObjectString_1.default, "qwerty").value()).toBe("qwerty");
    });
    test("createType", function () {
        expect(function () { return Reflection.createType(new ObjectString_1.default("Foo")); }).not.toThrowError();
        var Mock = Reflection.createType(new ObjectString_1.default("Foo"));
        expect(function () { return new Mock; }).not.toThrowError();
        expect(new Mock().name()).toBe("[object Foo]");
    });
    test("typeOf", function () {
        expect(Reflection.typeOf(ObjectArray_1.default)).toBe("[object Array]");
        expect(Reflection.typeOf(ObjectObject_1.default)).toBe("[object Object]");
        expect(Reflection.typeOf(ObjectString_1.default)).toBe("[object String]");
    });
});
