"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createErrorMock(ErrorConstructor) {
    return describe(ErrorConstructor.name, function () {
        test('It can be instanced', function () {
            return expect(function () { return new ErrorConstructor(); }).not.toThrowError();
        });
        test('It has a message', function () {
            return expect(new ErrorConstructor()).toHaveProperty('message');
        });
        test('It has a name', function () {
            return expect(new ErrorConstructor()).toHaveProperty('name');
        });
        test('It has a stack', function () {
            return expect(new ErrorConstructor()).toHaveProperty('name');
        });
        test('It has a create static method', function () {
            return expect('create' in ErrorConstructor).toBeDefined();
        });
        test("Static create will return an instance of " + ErrorConstructor.name, function () {
            var mocked = new Proxy({}, {
                get: function () { return jest.fn().mockReturnValue('a'); },
            });
            var mocks = [];
            while (mocks.length < 10) {
                mocks.push(mocked);
            }
            expect(function () { return ErrorConstructor['create'].apply(null, mocks); }).not.toThrowError();
            expect(ErrorConstructor['create'].apply(null, mocks).name()).toBe(new ErrorConstructor().name());
        });
    });
}
exports.default = createErrorMock;
