"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectVariable_1 = __importDefault(require("@Types/ObjectVariable"));
var InvalidCastError_1 = __importDefault(require("@Types/Errors/InvalidCastError"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var Throw_1 = __importDefault(require("@Operators/Throw"));
var ObjectObject_1 = __importDefault(require("@Types/ObjectObject"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectArray_1 = __importDefault(require("@Types/ObjectArray"));
var ObjectFunction_1 = __importDefault(require("@Types/ObjectFunction"));
var ObjectVoid_1 = __importDefault(require("@Types/ObjectVoid"));
var DeclarationTableExpression = /** @class */ (function (_super) {
    __extends(DeclarationTableExpression, _super);
    function DeclarationTableExpression(variables) {
        if (variables === void 0) { variables = new ObjectArray_1.default(ObjectVariable_1.default); }
        var _this = _super.call(this) || this;
        variables.forEach(new ObjectFunction_1.default(function (variable) {
            _this.add(variable);
            return new ObjectVoid_1.default();
        }));
        return _this;
    }
    DeclarationTableExpression.prototype.add = function (variable) {
        this[variable.signedName().value()] = variable;
        return this;
    };
    DeclarationTableExpression.prototype.cast = function (type) {
        new Throw_1.default().left(new InvalidCastError_1.default(new ObjectString_1.default(""))).apply();
    };
    DeclarationTableExpression.prototype.get = function (name) {
        var prop = this[name.value()];
        if ('signedName' in prop) {
            return prop;
        }
        return new ObjectNull_1.default();
    };
    DeclarationTableExpression.prototype.name = function () {
        return "[object DeclarationTableExpression]";
    };
    DeclarationTableExpression.prototype.nullable = function () {
        return true;
    };
    return DeclarationTableExpression;
}(ObjectObject_1.default));
exports.default = DeclarationTableExpression;
