"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectBoolean_1 = __importDefault(require("@Types/ObjectBoolean"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectBit = /** @class */ (function (_super) {
    __extends(ObjectBit, _super);
    function ObjectBit(bit) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        if (bit !== TypeBase_1.default.skipToken && typeof bit !== 'number' && typeof bit !== 'boolean') {
            throw new InvalidCastError_1.default("Cannot convert " + Object.prototype.toString.call(bit) + " to " + _this.name());
        }
        _this['underlyingValue'] = !!bit ? 1 : 0;
        return _this;
    }
    ObjectBit.prototype.cast = function (type) {
        if (type.nullable() && type.value() === null) {
            return new ObjectBit(0);
        }
        if (type.equalsTo(ObjectNull_1.default) || type.equalsTo(ObjectUndefined_1.default)) {
            return new ObjectBit(0);
        }
        var returningValue = parseInt(type.value());
        if (isNaN(returningValue)) {
            return new ObjectBit(0);
        }
        return new ObjectBit(returningValue > 0 ? 1 : 0);
    };
    ObjectBit.prototype.name = function () {
        return '[object Bit]';
    };
    ObjectBit.prototype.nullable = function () {
        return false;
    };
    ObjectBit.prototype.toBoolean = function () {
        return new ObjectBoolean_1.default(this.value() === 1);
    };
    return ObjectBit;
}(TypeBase_1.default));
exports.default = ObjectBit;
