import ObjectBitArray from '@Types/ObjectBitArray';
import ObjectBit from '@Types/ObjectBit';
import TypeBase from '@Types/TypeBase';
import ObjectInt from '@Types/ObjectInt';
export default class ObjectByte extends TypeBase<number> {
    protected readonly bit0: ObjectBit;
    protected readonly bit1: ObjectBit;
    protected readonly bit2: ObjectBit;
    protected readonly bit3: ObjectBit;
    protected readonly bit4: ObjectBit;
    protected readonly bit5: ObjectBit;
    protected readonly bit6: ObjectBit;
    protected readonly bit7: ObjectBit;
    protected readonly bit8: ObjectBit;
    /**
     * Creates an instance of ObjectByte.
     * @param {(null | number)} arg
     * @memberof ObjectByte
     */
    constructor(arg: null | number);
    /**
     * @protected
     * @param {number} value
     * @returns {boolean}
     * @memberof ObjectByte
     */
    protected isInRange(value: number): boolean;
    /**
     * @template T
     * @param {T} type
     * @returns {TypeBase<number>}
     * @memberof ObjectByte
     */
    cast<T extends TypeBase<unknown>>(type: T): TypeBase<number>;
    /**
     * @param {ObjectInt} position
     * @returns {ObjectBit}
     * @memberof ObjectByte
     */
    item(position: ObjectInt): ObjectBit;
    /**
     * @returns {string}
     * @memberof ObjectByte
     */
    name(): string;
    /**
     * @returns {boolean}
     * @memberof ObjectByte
     */
    nullable(): boolean;
    /**
     * @returns {ObjectBitArray}
     * @memberof ObjectByte
     */
    toBitArray(): ObjectBitArray;
    /**
     * @returns {ObjectInt}
     * @memberof ObjectByte
     */
    toInt(): ObjectInt;
    /**
     * @param {(ObjectInt | ObjectByte)} [value]
     * @returns {number}
     * @memberof ObjectByte
     */
    value(value?: ObjectInt | ObjectByte): number;
}
