"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OutOfRangeError_1 = __importDefault(require("@InternalErrors/OutOfRangeError"));
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectBitArray_1 = __importDefault(require("@Types/ObjectBitArray"));
var ObjectBit_1 = __importDefault(require("@Types/ObjectBit"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectByte = /** @class */ (function (_super) {
    __extends(ObjectByte, _super);
    /**
     * Creates an instance of ObjectByte.
     * @param {(null | number)} arg
     * @memberof ObjectByte
     */
    function ObjectByte(arg) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        if (arg === null) {
            arg = 0;
        }
        if (typeof arg !== 'number' && arg !== ObjectBit_1.default.skipToken) {
            throw new InvalidCastError_1.default("Cannot implicitily convert " + _this.getUnderlyingTypeOf(arg) + " to " + _this.name());
        }
        if (arg < 0 || arg > 256) {
            throw OutOfRangeError_1.default.create(new ObjectInt_1.default(0), new ObjectInt_1.default(255));
        }
        _this['underlyingValue'] = arg;
        _this.bit0 = new ObjectBit_1.default(0);
        _this.bit1 = new ObjectBit_1.default(0);
        _this.bit2 = new ObjectBit_1.default(0);
        _this.bit3 = new ObjectBit_1.default(0);
        _this.bit4 = new ObjectBit_1.default(0);
        _this.bit5 = new ObjectBit_1.default(0);
        _this.bit6 = new ObjectBit_1.default(0);
        _this.bit7 = new ObjectBit_1.default(0);
        _this.bit8 = new ObjectBit_1.default(0);
        var bitLike = arg.toString(2);
        for (var i = 0; i < 8; i++) {
            _this.item(new ObjectInt_1.default(i)).value(new ObjectBit_1.default(parseInt(bitLike[i])));
        }
        return _this;
    }
    /**
     * @protected
     * @param {number} value
     * @returns {boolean}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.isInRange = function (value) {
        return value > 0 && value < 256;
    };
    /**
     * @template T
     * @param {T} type
     * @returns {TypeBase<number>}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.cast = function (type) {
        if (type.equalsTo(ObjectNull_1.default)) {
            return new ObjectByte(0);
        }
        return new ObjectByte(this['underlyingValue']);
    };
    /**
     * @param {ObjectInt} position
     * @returns {ObjectBit}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.item = function (position) {
        if (position.value() < 0 || position.value() > 8) {
            throw OutOfRangeError_1.default.create(new ObjectInt_1.default(0), new ObjectInt_1.default(8));
        }
        return this["bit" + position.value()];
    };
    /**
     * @returns {string}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.name = function () {
        return "[object Byte]";
    };
    /**
     * @returns {boolean}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.nullable = function () {
        return false;
    };
    /**
     * @returns {ObjectBitArray}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.toBitArray = function () {
        var instance = new ObjectBitArray_1.default();
        for (var i = 0; i < 8; i++) {
            instance.push(this.item(new ObjectInt_1.default(i)));
        }
        return instance;
    };
    /**
     * @returns {ObjectInt}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.toInt = function () {
        var bitArray = [];
        for (var i = 0; i < 8; i++) {
            bitArray.push((this.item(new ObjectInt_1.default(i)).value()));
        }
        return new ObjectInt_1.default(parseInt(bitArray.join(''), 2));
    };
    /**
     * @param {(ObjectInt | ObjectByte)} [value]
     * @returns {number}
     * @memberof ObjectByte
     */
    ObjectByte.prototype.value = function (value) {
        if (value !== undefined) {
            var stringarray = value.value().toString(2);
            for (var i = 0; i < 8; i++) {
                this.item(new ObjectInt_1.default(i)).value(new ObjectInt_1.default(parseInt(stringarray[i])));
            }
        }
        return this.toInt().value();
    };
    return ObjectByte;
}(TypeBase_1.default));
exports.default = ObjectByte;
