"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectChar = /** @class */ (function (_super) {
    __extends(ObjectChar, _super);
    /**
     * Creates an instance of ObjectChar.
     * @param {string} char
     * @memberof ObjectChar
     */
    function ObjectChar(char) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        if (typeof char === "number") {
            _this['underlyingValue'] = String.fromCharCode(char);
        }
        else if (typeof char === 'string' && char === TypeBase_1.default.skipToken) {
            _this['underlyingValue'] = 'a';
        }
        else if (typeof char === 'string' && char !== TypeBase_1.default.skipToken && char.length === 1) {
            _this['underlyingValue'] = char;
        }
        else {
            throw new InvalidCastError_1.default("Implicit conversion from " + Object.prototype.toString.call(char) + " " + _this.name());
        }
        return _this;
    }
    /**
     * @template T
     * @param {T} type
     * @returns {string}
     * @memberof Char
     */
    ObjectChar.prototype.cast = function (type) {
        if (type.equalsTo(ObjectInt_1.default)) {
            return new ObjectChar(String.fromCharCode(type.value()));
        }
        if (type.equalsTo(ObjectString_1.default) && type.toString().length === 1) {
            return new ObjectChar(type.value());
        }
        throw new InvalidCastError_1.default("Cannot convert " + type.name() + " to " + this.name());
    };
    /**
     * @returns {ObjectInt}
     * @memberof ObjectChar
     */
    ObjectChar.prototype.charCode = function () {
        return this.toInt();
    };
    /**
     * @returns {string}
     * @memberof Char
     */
    ObjectChar.prototype.name = function () {
        return '[object Char]';
    };
    /**
     * @returns {boolean}
     * @memberof Char
     */
    ObjectChar.prototype.nullable = function () {
        return false;
    };
    /**
     * @returns {ObjectInt}
     * @memberof ObjectChar
     */
    ObjectChar.prototype.toInt = function () {
        return new ObjectInt_1.default(this.value().charCodeAt(0));
    };
    return ObjectChar;
}(TypeBase_1.default));
exports.default = ObjectChar;
