"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectDecimal = /** @class */ (function (_super) {
    __extends(ObjectDecimal, _super);
    function ObjectDecimal(arg) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        if (typeof arg !== 'number' && arg !== TypeBase_1.default.skipToken) {
            throw new InvalidCastError_1.default("Implicit conversion from " + Object.prototype.toString.call(arg) + " to " + _this.name());
        }
        _this['underlyingValue'] = parseFloat(parseFloat(arg).toFixed(2));
        return _this;
    }
    ObjectDecimal.prototype.cast = function (type) {
        if (type.nullable() && type.value() === null) {
            return new ObjectDecimal(0);
        }
        if (type.equalsTo(ObjectNull_1.default) || type.equalsTo(ObjectUndefined_1.default)) {
            return new ObjectDecimal(0);
        }
        var returningValue = parseFloat(parseFloat(type.value()).toFixed(2));
        if (isNaN(returningValue)) {
            return new ObjectDecimal(0);
        }
        return new ObjectDecimal(returningValue);
    };
    ObjectDecimal.prototype.name = function () {
        return "[object Decimal]";
    };
    ObjectDecimal.prototype.nullable = function () {
        return false;
    };
    return ObjectDecimal;
}(TypeBase_1.default));
exports.default = ObjectDecimal;
