"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var Throw_1 = __importDefault(require("@Operators/Throw"));
var ObjectError = /** @class */ (function (_super) {
    __extends(ObjectError, _super);
    function ObjectError(errorMessage) {
        if (errorMessage === void 0) { errorMessage = new ObjectString_1.default(""); }
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        _this.stack = new ObjectString_1.default(new Error().stack);
        _this.message = errorMessage;
        return _this;
    }
    ObjectError.prototype.cast = function (type) {
        throw new InvalidCastError_1.default("Cannot convert any type to " + this.name());
    };
    ObjectError.prototype.name = function () {
        return "[object Error]";
    };
    ObjectError.prototype.nullable = function () {
        return false;
    };
    ObjectError.prototype.throw = function () {
        var op = new Throw_1.default();
        op.left(this);
        op.apply();
    };
    return ObjectError;
}(TypeBase_1.default));
exports.default = ObjectError;
