"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var ObjectFloat = /** @class */ (function (_super) {
    __extends(ObjectFloat, _super);
    function ObjectFloat(arg) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        if (typeof arg !== 'number' && arg !== TypeBase_1.default.skipToken) {
            throw new InvalidCastError_1.default("Implicit conversion from " + Object.prototype.toString.call(arg) + " to " + _this.name());
        }
        _this['underlyingValue'] = arg;
        return _this;
    }
    ObjectFloat.prototype.cast = function (type) {
        if (type.nullable() && type.value() === null) {
            return new ObjectFloat(0);
        }
        if (type.equalsTo(ObjectNull_1.default) || type.equalsTo(ObjectUndefined_1.default)) {
            return new ObjectFloat(0);
        }
        var returningValue = parseFloat(type.value());
        if (isNaN(returningValue)) {
            return new ObjectFloat(0);
        }
        return new ObjectFloat(returningValue);
    };
    ObjectFloat.prototype.name = function () {
        return "[object Float]";
    };
    ObjectFloat.prototype.nullable = function () {
        return false;
    };
    return ObjectFloat;
}(TypeBase_1.default));
exports.default = ObjectFloat;
