"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectObject = /** @class */ (function (_super) {
    __extends(ObjectObject, _super);
    function ObjectObject(value) {
        var _this = _super.call(this, value) || this;
        if (value === undefined) {
            throw InvalidCastError_1.default.create(new ObjectUndefined_1.default(), _this);
        }
        if (value === null) {
            throw InvalidCastError_1.default.create(new ObjectNull_1.default(), _this);
        }
        if (typeof value !== 'object' && value !== TypeBase_1.default.skipToken) {
            throw new TypeError("Invalid argument");
        }
        if (Object.prototype.toString.call(value) === _this.name()) {
            Object.keys(value).forEach(function (key) {
                _this[key] = value;
            });
        }
        return _this;
    }
    /**
     * @template T
     * @param {T} type
     * @returns {object}
     * @memberof ObjectObject
     */
    ObjectObject.prototype.cast = function (type) {
        if (type.nullable() && type.value() === null) {
            throw InvalidCastError_1.default.create(type, this);
        }
        return new ObjectObject(Object.create(type));
    };
    /**
     * @returns {string}
     * @memberof ObjectObject
     */
    ObjectObject.prototype.name = function () {
        return "[object Object]";
    };
    /**
     * @returns {boolean}
     * @memberof ObjectObject
     */
    ObjectObject.prototype.nullable = function () {
        return true;
    };
    return ObjectObject;
}(TypeBase_1.default));
exports.default = ObjectObject;
