import TypeBase from '@Types/TypeBase';
import ObjectInt from '@Types/ObjectInt';
import ObjectArray from '@Types/ObjectArray';
import ObjectChar from '@Types/ObjectChar';
export default class ObjectString extends TypeBase<string> {
    /**
     * @template T
     * @param {T} type
     * @returns {string}
     * @memberof String
     */
    cast<T extends TypeBase<unknown>>(type: T): ObjectString;
    length(): ObjectInt;
    /**
     * @returns {string}
     * @memberof String
     */
    name(): string;
    /**
     * @returns {boolean}
     * @memberof String
     */
    nullable(): boolean;
    /**
     * @returns {ObjectArray<ObjectChar>}
     * @memberof ObjectString
     */
    toCharArray(): ObjectArray<ObjectChar>;
    /**
     * @returns {ObjectArray<ObjectInt>}
     * @memberof ObjectString
     */
    toIntArray(): ObjectArray<ObjectInt>;
}
