"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
var ObjectArray_1 = __importDefault(require("@Types/ObjectArray"));
var ObjectChar_1 = __importDefault(require("@Types/ObjectChar"));
var ObjectString = /** @class */ (function (_super) {
    __extends(ObjectString, _super);
    function ObjectString() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @template T
     * @param {T} type
     * @returns {string}
     * @memberof String
     */
    ObjectString.prototype.cast = function (type) {
        if (type.equalsTo(ObjectNull_1.default) || type.equalsTo(ObjectUndefined_1.default)) {
            return new ObjectString('');
        }
        return new ObjectString(type.toString());
    };
    ObjectString.prototype.length = function () {
        return new ObjectInt_1.default(this.value().length);
    };
    /**
     * @returns {string}
     * @memberof String
     */
    ObjectString.prototype.name = function () {
        return "[object String]";
    };
    /**
     * @returns {boolean}
     * @memberof String
     */
    ObjectString.prototype.nullable = function () {
        return false;
    };
    /**
     * @returns {ObjectArray<ObjectChar>}
     * @memberof ObjectString
     */
    ObjectString.prototype.toCharArray = function () {
        var chunks = this['underlyingValue'].split('').map(function (chunk) { return new ObjectChar_1.default(chunk); });
        return new ObjectArray_1.default(ObjectChar_1.default, chunks);
    };
    /**
     * @returns {ObjectArray<ObjectInt>}
     * @memberof ObjectString
     */
    ObjectString.prototype.toIntArray = function () {
        var chunks = this['underlyingValue'].split('').map(function (chunk) { return new ObjectChar_1.default(chunk).charCode(); });
        return new ObjectArray_1.default(ObjectInt_1.default, chunks);
    };
    return ObjectString;
}(TypeBase_1.default));
exports.default = ObjectString;
