import { ConstructorOf } from '@Types/ConstructorOf';
import TypeBase from '@Types/TypeBase';
import ObjectString from '@Types/ObjectString';
import ObjectNull from './ObjectNull';
export default class ObjectVariable<TValue extends TypeBase = TypeBase> extends TypeBase<TValue | ObjectNull> {
    private TypeChecker;
    private _mutable;
    private _signedName;
    constructor(Type: ConstructorOf<TValue>, name: ObjectString, value: TValue);
    cast<T extends TypeBase<unknown>>(type: T): TypeBase<any>;
    immutable(): ObjectVariable<TValue>;
    mutable(): ObjectVariable<TValue>;
    name(): string;
    nullable(): boolean;
    /**
     * @returns {ObjectString}
     * @memberof ObjectVariable
     */
    signedName(): ObjectString;
    value(value?: TValue | ObjectNull): TValue | ObjectNull;
}
