"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var InvalidCastError_1 = __importDefault(require("@InternalErrors/InvalidCastError"));
var TypeBase_1 = __importDefault(require("@Types/TypeBase"));
var ObjectBoolean_1 = __importDefault(require("./ObjectBoolean"));
var Throw_1 = __importDefault(require("@Operators/Throw"));
var ImmutableValueError_1 = __importDefault(require("./Errors/ImmutableValueError"));
var ObjectNull_1 = __importDefault(require("./ObjectNull"));
var ObjectVariable = /** @class */ (function (_super) {
    __extends(ObjectVariable, _super);
    function ObjectVariable(Type, name, value) {
        var _this = _super.call(this, TypeBase_1.default.skipToken) || this;
        _this._mutable = new ObjectBoolean_1.default(false);
        _this.TypeChecker = Type;
        _this['underlyingValue'] = value;
        _this._signedName = name;
        return _this;
    }
    ObjectVariable.prototype.cast = function (type) {
        if (!type.equalsTo(this.TypeChecker)) {
            throw InvalidCastError_1.default.create(type, this);
        }
        if (type.equalsTo(ObjectNull_1.default)) {
            throw InvalidCastError_1.default.create(type, this);
        }
        return this.value().cast(type);
    };
    ObjectVariable.prototype.immutable = function () {
        this._mutable = new ObjectBoolean_1.default(false);
        return this;
    };
    ObjectVariable.prototype.mutable = function () {
        this._mutable = new ObjectBoolean_1.default(true);
        return this;
    };
    ObjectVariable.prototype.name = function () {
        return "[object Variable]";
    };
    ObjectVariable.prototype.nullable = function () {
        return true;
    };
    /**
     * @returns {ObjectString}
     * @memberof ObjectVariable
     */
    ObjectVariable.prototype.signedName = function () {
        return this._signedName;
    };
    ObjectVariable.prototype.value = function (value) {
        if (this._mutable.isFalse().value() && value) {
            return new Throw_1.default().left(ImmutableValueError_1.default.create(this)).apply();
        }
        if (value && !value.equalsTo(ObjectNull_1.default)) {
            this['underlyingValue'] = value;
        }
        if (value && value.equalsTo(ObjectNull_1.default)) {
            this['underlyingValue'] = new ObjectNull_1.default();
        }
        return this['underlyingValue'];
    };
    return ObjectVariable;
}(TypeBase_1.default));
exports.default = ObjectVariable;
