"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectArray_1 = __importDefault(require("@Types/ObjectArray"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
describe(ObjectArray_1.default.name, function () {
    basetests.hasEqualsTo(ObjectArray_1.default);
    basetests.hasName(ObjectArray_1.default);
    basetests.hasToString(ObjectArray_1.default);
    basetests.hasValue(ObjectArray_1.default);
    basetests.isNullable(ObjectArray_1.default, false);
    test(ObjectArray_1.default.prototype.item.name, function () {
        var arr = new ObjectArray_1.default(ObjectString_1.default, []);
        var arr2 = new ObjectArray_1.default(ObjectString_1.default, [new ObjectString_1.default('qqqq')]);
        expect(arr.item(new ObjectInt_1.default(0)).equalsTo(ObjectNull_1.default)).toBeTruthy();
        expect(arr2.item(new ObjectInt_1.default(0)).equalsTo(ObjectString_1.default)).toBeTruthy();
        expect(arr2.item(new ObjectInt_1.default(0)).name()).toEqual(new ObjectString_1.default('').name());
        expect(arr2.item(new ObjectInt_1.default(0)).value()).toEqual(new ObjectString_1.default('qqqq').value());
    });
    test(ObjectArray_1.default.prototype.length.name, function () {
        var arr = new ObjectArray_1.default(ObjectString_1.default, []);
        var arr2 = new ObjectArray_1.default(ObjectString_1.default, [new ObjectString_1.default('qqqq')]);
        expect(arr.length().value()).toBe(new ObjectInt_1.default(0).value());
        expect(arr2.length().value()).toBe(new ObjectInt_1.default(1).value());
    });
    test(ObjectArray_1.default.prototype.pop.name, function () {
        var arr = new ObjectArray_1.default(ObjectString_1.default, [new ObjectString_1.default('a'), new ObjectString_1.default('b')]);
        expect(arr.length().value()).toBe(new ObjectInt_1.default(2).value());
        expect(arr.pop().name()).toEqual(new ObjectString_1.default('').name());
        expect(arr.length().value()).toBe(new ObjectInt_1.default(1).value());
        expect(arr.pop().name()).toEqual(new ObjectString_1.default('').name());
        expect(arr.length().value()).toBe(new ObjectInt_1.default(0).value());
        expect(function () { return arr.pop(); }).not.toThrowError();
        expect(function () { return arr.pop(); }).not.toThrowError();
        expect(function () { return arr.pop(); }).not.toThrowError();
        expect(function () { return arr.pop(); }).not.toThrowError();
    });
    test(ObjectArray_1.default.prototype.push.name, function () {
        var arr = new ObjectArray_1.default(ObjectString_1.default, []);
        arr.push(new ObjectString_1.default(''));
        expect(arr.length().value()).toEqual(new ObjectInt_1.default(1).value());
        arr.push(new ObjectString_1.default(''));
        expect(arr.length().value()).toEqual(new ObjectInt_1.default(2).value());
        arr.push(new ObjectString_1.default(''));
        expect(arr.length().value()).toEqual(new ObjectInt_1.default(3).value());
    });
});
