"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectBit_1 = __importDefault(require("@Types/ObjectBit"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectBoolean_1 = __importDefault(require("@Types/ObjectBoolean"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
var ObjectUndefined_1 = __importDefault(require("@Types/ObjectUndefined"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe(ObjectBit_1.default.name, function () {
    basetests.hasEqualsTo(ObjectBit_1.default);
    basetests.hasName(ObjectBit_1.default);
    basetests.hasToString(ObjectBit_1.default);
    basetests.hasValue(ObjectBit_1.default);
    basetests.isNullable(ObjectBit_1.default, false);
    it(ObjectBit_1.default.prototype.toBoolean.name, function () {
        var bit = new ObjectBit_1.default(1);
        expect(typeof bit.toBoolean).toBe('function');
        expect(bit.toBoolean()).toBeDefined();
        expect(typeof bit.toBoolean()).toBe('object');
        expect(bit.toBoolean().equalsTo(ObjectBoolean_1.default)).toBeTruthy();
    });
    it('Casts every kind of Object to a Bit', function () {
        var bit = new ObjectBit_1.default(1);
        expect(bit.cast(new ObjectString_1.default('')).value()).toBe(0);
        expect(bit.cast(new ObjectNull_1.default()).value()).toBe(0);
        expect(bit.cast(new ObjectUndefined_1.default()).value()).toBe(0);
        expect(bit.cast(new ObjectInt_1.default(10)).value()).toBe(1);
        expect(bit.cast(new ObjectInt_1.default(-10)).value()).toBe(0);
    });
});
