"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectByte_1 = __importDefault(require("@Types/ObjectByte"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
var ObjectBitArray_1 = __importDefault(require("@Types/ObjectBitArray"));
describe(ObjectByte_1.default.name, function () {
    basetests.hasEqualsTo(ObjectByte_1.default);
    basetests.hasName(ObjectByte_1.default);
    basetests.hasToString(ObjectByte_1.default);
    basetests.hasValue(ObjectByte_1.default);
    basetests.isNullable(ObjectByte_1.default, false);
    test("ObjectByte.prototype.item", function () {
        var byte = new ObjectByte_1.default(0);
        expect(byte.item(new ObjectInt_1.default(0)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(1)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(2)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(3)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(4)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(5)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(6)).value()).toBe(0);
        expect(byte.item(new ObjectInt_1.default(7)).value()).toBe(0);
    });
    test("ObjectByte.prototype.toBitArray", function () {
        expect(function () { return new ObjectByte_1.default(0).toBitArray().equalsTo(ObjectBitArray_1.default); }).toBeTruthy();
    });
    test("ObjectByte.prototype.toInt", function () {
        expect(new ObjectByte_1.default(0).toInt().equalsTo(ObjectInt_1.default)).toBeTruthy();
    });
    test("ObjectByte.prototype.value", function () {
        var byte = new ObjectByte_1.default(0);
        expect(byte.value()).toBe(0);
        expect(function () { return byte.value(new ObjectInt_1.default(255)); }).not.toThrow();
        expect(byte.value()).toBe(255);
    });
});
