"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectFunction_1 = __importDefault(require("@Types/ObjectFunction"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe(ObjectFunction_1.default.name, function () {
    basetests.hasEqualsTo(ObjectFunction_1.default);
    basetests.hasName(ObjectFunction_1.default);
    basetests.hasToString(ObjectFunction_1.default);
    basetests.hasValue(ObjectFunction_1.default);
    basetests.isNullable(ObjectFunction_1.default, false);
    test("ObjectFunction.prototype.apply", function () {
        var mock = jest.fn().mockReturnValue(new ObjectInt_1.default(10));
        var fn = new ObjectFunction_1.default(mock);
        expect(function () { return fn.call(); }).not.toThrow();
        expect(mock).toHaveBeenCalled();
    });
    test("ObjectFunction.prototype.call", function () {
        var mock = jest.fn().mockReturnValue(new ObjectInt_1.default(10));
        var fn = new ObjectFunction_1.default(mock);
        expect(function () { return fn.apply([]); }).not.toThrow();
        expect(mock).toHaveBeenCalled();
    });
});
