"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectInt_1 = __importDefault(require("@Types/ObjectInt"));
describe(ObjectString_1.default.name, function () {
    basetests.hasEqualsTo(ObjectString_1.default);
    basetests.hasName(ObjectString_1.default);
    basetests.hasToString(ObjectString_1.default);
    basetests.hasValue(ObjectString_1.default);
    basetests.isNullable(ObjectString_1.default, false);
    test(ObjectString_1.default.prototype.length.name, function () {
        var str = new ObjectString_1.default('lorem');
        expect(str.length().equalsTo(ObjectInt_1.default)).toBeTruthy();
        expect(str.length().value()).toBe(5);
    });
    test(ObjectString_1.default.prototype.toCharArray.name, function () {
        var str = new ObjectString_1.default('lorem');
        expect(str.value().length).toBe(5);
        expect(function () { return str.toCharArray(); }).not.toThrowError();
        expect(str.toCharArray().length().value()).toBe(5);
        expect(str.toCharArray().item(new ObjectInt_1.default(0)).value()).toBe('l');
        expect(str.toCharArray().item(new ObjectInt_1.default(1)).value()).toBe('o');
        expect(str.toCharArray().item(new ObjectInt_1.default(2)).value()).toBe('r');
        expect(str.toCharArray().item(new ObjectInt_1.default(3)).value()).toBe('e');
        expect(str.toCharArray().item(new ObjectInt_1.default(4)).value()).toBe('m');
    });
    test(ObjectString_1.default.prototype.toIntArray.name, function () {
        var str = new ObjectString_1.default('lorem');
        expect(str.value().length).toBe(5);
        expect(function () { return str.toIntArray(); }).not.toThrowError();
        expect(str.toIntArray().length().value()).toBe(5);
        expect(str.toIntArray().item(new ObjectInt_1.default(0)).value()).toBe(108);
        expect(str.toIntArray().item(new ObjectInt_1.default(1)).value()).toBe(111);
        expect(str.toIntArray().item(new ObjectInt_1.default(2)).value()).toBe(114);
        expect(str.toIntArray().item(new ObjectInt_1.default(3)).value()).toBe(101);
        expect(str.toIntArray().item(new ObjectInt_1.default(4)).value()).toBe(109);
    });
});
