"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var basetests = __importStar(require("./__ignore__/baseTests"));
var ObjectVariable_1 = __importDefault(require("@Types/ObjectVariable"));
var ObjectString_1 = __importDefault(require("@Types/ObjectString"));
var ObjectNull_1 = __importDefault(require("@Types/ObjectNull"));
describe(ObjectVariable_1.default.name, function () {
    basetests.hasEqualsTo(ObjectVariable_1.default);
    basetests.hasName(ObjectVariable_1.default);
    basetests.hasToString(ObjectVariable_1.default);
    basetests.hasValue(ObjectVariable_1.default);
    basetests.isNullable(ObjectVariable_1.default, true);
    it("Checks mutability", function () {
        var variable = new ObjectVariable_1.default(ObjectString_1.default, new ObjectString_1.default("const"), new ObjectString_1.default("immutaaaable"));
        expect(function () { return variable.immutable(); }).not.toThrowError();
        expect(function () { return variable.value(new ObjectString_1.default("exploooode")); }).toThrowError();
        expect(function () { return variable.mutable(); }).not.toThrowError();
        expect(function () { return variable.value(new ObjectString_1.default("exploooode")); }).not.toThrowError();
    });
    it("Has a name", function () {
        var variable = new ObjectVariable_1.default(ObjectString_1.default, new ObjectString_1.default("const"), new ObjectString_1.default(""));
        expect(variable.signedName().value()).toBe("const");
    });
    it("If passing a null value, it will have a ObjectNull", function () {
        var variable = new ObjectVariable_1.default(ObjectString_1.default, new ObjectString_1.default("const"), new ObjectString_1.default(""));
        expect(variable.mutable().value(new ObjectNull_1.default()).value()).toBeNull();
        expect(variable.value().equalsTo(ObjectNull_1.default)).toBeTruthy();
    });
});
