"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var TypeBase_1 = __importDefault(require("../../TypeBase"));
function instance(Constructor) {
    return new Constructor(TypeBase_1.default.skipToken);
}
/**
 *
 * @export
 * @param {ConstructorOf<TypeBase>} Constructor
 */
function hasEqualsTo(Constructor) {
    it(Constructor.name + " has instance member \"equalsTo\"", function () {
        var fn = jest.fn();
        var Mock = /** @class */ (function () {
            function class_1() {
                this.name = fn;
            }
            return class_1;
        }());
        expect(instance(Constructor)).toHaveProperty('equalsTo');
        expect(function () { return instance(Constructor).equalsTo(Mock); }).not.toThrowError();
        expect(typeof instance(Constructor).equalsTo(Mock)).toBe('boolean');
        expect(fn).toBeCalled();
    });
}
exports.hasEqualsTo = hasEqualsTo;
/**
 *
 * @export
 * @param {ConstructorOf<TypeBase>} Constructor
 */
function hasName(Constructor) {
    it(Constructor.name + " has instance member \"name\"", function () {
        expect(instance(Constructor)).toHaveProperty('name');
        expect(function () { return instance(Constructor).name(); }).not.toThrowError();
        expect(typeof instance(Constructor).name()).toBe('string');
    });
}
exports.hasName = hasName;
/**
 *
 * @export
 * @param {ConstructorOf<TypeBase>} Constructor
 */
function hasToString(Constructor) {
    it(Constructor.name + " has instance member \"toString\"", function () {
        expect(instance(Constructor)).toHaveProperty('toString');
        expect(function () { return instance(Constructor).toString(); }).not.toThrowError();
        expect(typeof instance(Constructor).toString()).toEqual('string');
    });
}
exports.hasToString = hasToString;
/**
 *
 * @export
 * @param {ConstructorOf<TypeBase>} Constructor
 */
function hasValue(Constructor) {
    it(Constructor.name + " has instance member \"value\"", function () {
        expect(instance(Constructor)).toHaveProperty('value');
        expect(function () { return instance(Constructor).value(); }).not.toThrowError();
    });
}
exports.hasValue = hasValue;
/**
 *
 * @export
 * @param {ConstructorOf<TypeBase>} Constructor
 */
function isNullable(Constructor, condition) {
    it(Constructor.name + " is a nullable type", function () {
        expect(instance(Constructor)).toHaveProperty('nullable');
        expect(function () { return instance(Constructor).nullable(); }).not.toThrowError();
        expect(typeof instance(Constructor).nullable()).toBe('boolean');
        expect(instance(Constructor).nullable()).toBe(condition);
    });
}
exports.isNullable = isNullable;
